/* gc-aux.h */

/*****************************************************************/
/* macros diverses pour acceder aux structures de donnees du gc. */
/*****************************************************************/

#ifndef _gc_aux_
#define _gc_aux_


#include "mlvalues.h"

extern address to_start, to_end, young_start, young_end, from_start, from_end;
extern address heap_start, heap_end;

/* tests d'appartenance */

#define IS_IN_HEAP(obj) \
  (ADDRESS(obj) >= heap_start && ADDRESS(obj) < heap_end)

#define IS_IN_FROM_SPACE(obj) \
  (ADDRESS(obj) >= from_start && ADDRESS(obj) < from_end)

#define IS_IN_TO_SPACE(obj) \
  (ADDRESS(obj) >= to_start && ADDRESS(obj) < to_end)

#define IS_IN_MS_SPACE(obj) \
  (IS_IN_HEAP (obj) && !IS_IN_FROM_SPACE (obj) && !IS_IN_TO_SPACE (obj))

#define IS_INSIDE_FROM_SPACE(obj, lg) \
  (ADDRESS(obj) >= from_start && (ADDRESS(obj) + (lg)) <= from_end)

#define IS_YOUNG(obj) \
  ((address) (obj) < young_end && (address) (obj) >= young_start)


/* gestion des pointeurs d'indirection */

#define IS_FORWARDED IS_BLUE

#define FORWARD_POINTER CAR

#define PUT_FORWARD_FLAG(obj) \
    { Zassert (IS_WHITE (obj)); WHITE_TO_BLUE (obj); }

#define REMOVE_FORWARD_FLAG ANY_TO_WHITE


#endif /* _gc_aux_ */
